% clc, clear, close all;

load('Base_Chica_Siembra.mat')

load('ABC_Siembra_Neurona_Norm_Logsig_1.mat')
% load('ABC_Siembra_Neurona_Norm_Logsig_2.mat')
% load('ABC_Siembra_Neurona_Norm_Logsig_3.mat')

for car = 1:size(PCA, 2)
    a = max(PCA(:, car));
    b = min(PCA(:, car));
    PCA(:, car) = (PCA(:, car) - b) ./ (a - b);
end

figure(9), hold on
etiqueta = SIEMBRA_DATOS(:,175);
label    = num2cell(num2str(etiqueta));
v        = double(categorical(label));
c        = full(sparse(1:numel(v),v,ones(size(v)),numel(v),10));
cc       = dato2color(c);
scatter3(PCA(:,1), PCA(:,2), PCA(:,3), 15, cc, 'filled')
% scatter3(PCA_n(:,1), PCA_n(:,2), PCA_n(:,3), 15, cc, 'filled')
view(-50,8)
grid on
title('Reference Neural Network', 'FontSize', 18)
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

%% Cluster k_means para obtener la dispersion del error
% Aqui se realiza para la base de datos n'umeros con neurona spiking de
% tipo no lineal
% % % for ii = 1:7
% % % figure(2), hold on
% % % a = find(SIEMBRA_DATOS(:,175) == ii);
% % % aa1 = PCA(a,1); %<== Respuesta de la primera neurona
% % % bb1 = PCA(a,2); %<== Respuesta de la segunda neurona
% % % cc1 = PCA(a,3); %<== Respuesta de la tercera neurona
% % % c1 = mean(aa1);
% % % c2 = mean(bb1);
% % % c3 = mean(cc1);
% % % r1 = iqr(aa1,'all');
% % % r2 = iqr(bb1,'all');
% % % r3 = iqr(cc1,'all');
% % % y1 = mad(aa1);
% % % y2 = mad(bb1);
% % % y3 = mad(cc1);
% % % yy1 = range(aa1,'all');
% % % yy2 = range(bb1,'all');
% % % yy3 = range(cc1,'all');
% % % v1 = var(aa1);
% % % v2 = var(bb1);
% % % v3 = var(cc1);
% % % s1 = std(aa1);
% % % s2 = std(bb1);
% % % s3 = std(cc1);
% % % datos_total1 = [c1; r1; y1; yy1; v1; s1;];
% % % datos_total2 = [c2; r2; y2; yy2; v2; s2;];
% % % datos_total3 = [c3; r3; y3; yy3; v3; s3;];
% % % scatter3(PCA(a,1), PCA(a,2), PCA(a,3), 15, [0.0, 0.0, 0.0], 'filled')
% % % % plot3(c1,c2, c3,'rx', 'MarkerSize',15,'LineWidth',3)
% % % xlim([0 1]), ylim([0 1]), zlim([0 1])
% % % view(-50,8)
% % % grid on
% % % xlabel('Dimension 1')
% % % ylabel('Dimension 2')
% % % zlabel('Dimension 3')
% % % hold off
% % % neu1(ii) = c1;
% % % neu2(ii) = c2;
% % % neu3(ii) = c3;
% % % end
% % % save('grafica_neurona_logsig_siembra.mat','neu1', 'neu2', 'neu3')


figure(2), hold on
b = find(SIEMBRA_DATOS(:,175) == 1);
scatter3(PCA(b,1), PCA(b,2), PCA(b,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(3), hold on
b = find(SIEMBRA_DATOS(:,175) == 2);
scatter3(PCA(b,1), PCA(b,2), PCA(b,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(4), hold on
c = find(SIEMBRA_DATOS(:,175) == 3);
scatter3(PCA(c,1), PCA(c,2), PCA(c,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(5), hold on
d = find(SIEMBRA_DATOS(:,175) == 4);
scatter3(PCA(d,1), PCA(d,2), PCA(d,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(6), hold on
e = find(SIEMBRA_DATOS(:,175) == 5);
scatter3(PCA(e,1), PCA(e,2), PCA(e,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(7), hold on
f = find(SIEMBRA_DATOS(:,175) == 6);
scatter3(PCA(f,1), PCA(f,2), PCA(f,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off

figure(8), hold on
g = find(SIEMBRA_DATOS(:,175) == 7);
scatter3(PCA(g,1), PCA(g,2), PCA(g,3), 15, [0.0, 0.0, 0.0], 'filled')
xlim([0 1]), ylim([0 1]), zlim([0 1])
view(-50,8)
grid on
xlabel('Dimension 1','FontSize', 18)
ylabel('Dimension 2','FontSize', 18)
zlabel('Dimension 3','FontSize', 18)
hold off



